/***********************************************
** filefolders.cpp     horseshoeFTPd          **
** Nick Byra                                  **
** 21/03/06                                   **
**                                            **
***********************************************/


#include "filefolders.h"
#include "helpfunctions.h"
#include "mem_manage.h"




//constructor for a folder if you send it its path and name
folder::folder(char *loc, char *dname)
{

	//calloc a buffer for the locatin and copy the location into it
	location = (char*)calloc(strlen(loc)+1,sizeof(char));
	strcpy_s(location,strlen(loc)+1,loc);

	//do the same thing for the name
	name = (char*)calloc(strlen(dname)+1,sizeof(char));
	strcpy_s(name,strlen(dname)+1,dname);


	//set all of the pointers to null to avoid any problems
	last = NULL;
	next = NULL;
	up = NULL;
	down = NULL;
	gfirst = NULL;
	ffirst = NULL;


}

//this is the constructor for a folder if you don't give it anything
folder::folder()
{
	//all the pointers are set to null
	next = NULL;
	last = NULL;
	up = NULL;
	down = NULL;
	gfirst = NULL;
	ffirst = NULL;
	//the name and the location are malloced to one and set to emptystings
	name = (char*)mymalloc(1);
	location = (char*)mymalloc(1);
	name[0] = '\0';
	location[0] = '\0';

}

//this is the destructor for folder
//it frees the memory malloced for the name and location strings
folder::~folder()
{
	free (name);
	free (location);
}


//these are the basic getters and setters for the varaibles, nothing fancy here
char* folder::getName()
{
	return name;
}

char* folder::getLocation()
{
	return location;
}

folder* folder::getNext()
{
	return next;
}

folder* folder::getLast()
{
	return last;
}


folder* folder::getUp()
{
	return up;
}

folder* folder::getDown()
{
	return down;
}


group* folder::getGfirst()
{
	return gfirst;
}

file* folder::getFfirst()
{
	return ffirst;
}


void folder::setNext(folder *n)
{
	next = n;
}

void folder::setLast(folder *l)
{
	last = l;
}

void folder::setUp(folder *n)
{
	up = n;
}

void folder::setDown(folder *l)
{
	down = l;
}



void folder::setName(char *a)
{

	name = (char*)myrealloc(name,(strlen(a)+1)*sizeof(char));
	strcpy_s(name,strlen(a)+1,a);
}

void folder::setLocation(char *a)
{
	location = (char*)myrealloc(location,(strlen(a)+1)*sizeof(char));
	strcpy_s(location,strlen(a)+1,a);
}


void folder::setGfirst(group* a)
{

	gfirst = a;

}

void folder::setFfirst(file* a)
{

	ffirst = a;

}




group::group(int gname, int permission, group *previous)
{
	name = gname;


	permissions = permission;
	last = previous;
	next = NULL;

	if(previous!=NULL)
	{
		previous->setNext(this);
	}

}
group::~group()
{

}

group::group()
{
	next = NULL;
	last = NULL;
}


void group::setName(int a)
{
	name =a;
}
void group::setPremissions(int a)
{
	permissions = a;
}

int group::getName()
{
	return name;
}

int group::getPremissions()
{
	return permissions;
}

group* group::getNext()
{
	return next;
}

group* group::getLast()
{
	return last;
}

void group::setNext(group *n)
{
	next = n;
}

void group::setLast(group *l)
{
	last = l;
}









file::file()
{
	next = NULL;
	last = NULL;
	path = (char*)mymalloc(sizeof(char));
	name = (char*)mymalloc(sizeof(char));
	owner = (char*)mymalloc(sizeof(char));

	path = '\0';
	name = '\0';
	owner = '\0';

	grp = -1;
}

file::~file()
{
	free (path);
	free (name);
	free (owner);

}
char* file::getPath()
{
	return path;
}

char* file::getName()
{
	return name;
}

char* file::getOwner()
{
	return owner;
}

int file::getGroup()
{
	return grp;
}

void file::setPath(char *a)
{
	path = (char*)myrealloc(path,(strlen(a)+1)*sizeof(char));
	strcpy_s(path,(strlen(a)+1),a);



}

void file::setName(char *a)
{
	name = (char*)myrealloc(name,(strlen(a)+1)*sizeof(char));
	strcpy_s(name,(strlen(a)+1),a);
}

void file::setOwner(char *a)
{
	owner = (char*)myrealloc(owner,(strlen(a)+1)*sizeof(char));
	strcpy_s(owner,(strlen(a)+1),a);
}

void file::setGroup(int a)
{
	grp = a;
}


file* file::getNext()
{
	return next;
}

file* file::getLast()
{
	return last;
}

void file::setNext(file *n)
{
	next = n;
}

void file::setLast(file *l)
{
	last = l;
}


bool file::getDir()
{
	return dir;
}

void file::setDir(bool a)
{
	dir =a;
}