/***********************************************
** filefoders.h        horseshoeFTPd          **
** Nick Byra                                  **
** 21/03/06                                   **
**                                            **
***********************************************/

#ifndef _FILEFOLDERS
#define _FILEFOLDERS

#include "stdafx.h"
#include <stdlib.h>
#include <string.h>
#include <iostream>



class group
{
public:
group(int gname, int permission, group *previous);
group();
~group();
int getName();
int getPremissions();
void setName(int a);
void setPremissions(int a);

group *getNext();
group *getLast();
void setNext(group *n);
void setLast(group *l);

private:
int name;
int permissions;
group *next;
group *last;


};

class file
{
public:
file();
~file();
char* getPath();
char* getName();
char* getOwner();
int getGroup();

void setPath(char *a);
void setName(char *a);
void setOwner(char *a);
void setGroup(int a);

file *getNext();
file *getLast();
void setNext(file *n);
void setLast(file *l);

bool getDir();
void setDir(bool a);

private:
char *path;
char *name;
char *owner;
int grp;
bool dir;

file *next;
file *last;

};


class folder
{
public:
folder(char *loc, char *dname);
folder();
~folder();
char* getName();
char* getLocation();
void setName(char* a);
void setLocation(char* a);
folder* getNext();
folder* getLast();
folder* getUp();
folder* getDown();
void setNext(folder *n);
void setLast(folder *l);
void setUp(folder *n);
void setDown(folder *l);
group* getGfirst();
void setGfirst(group* a);

file* getFfirst();
void setFfirst(file* a);




private:
char *location;
char *name;


folder *next;
folder *last;
folder *up;
folder *down;
group *gfirst;
file *ffirst;

};






#endif