/***********************************************
** ftp_options.cpp     horseshoeFTPd          **
** Nick Byra                                  **
** 21/03/06                                   **
**                                            **
***********************************************/



#include "ftp_options.h"
#include "xml_manager.h"
#include <iostream>
#include "crypt.h"
#include <string>
#include "consts.h"
#include "helpfunctions.h"
#include "mem_manage.h"

using namespace std;

ftp_options::ftp_options()
{

	//load default values for ftp

	strncpy_s(name,50,"Test FTPd",strlen("Test FTPd"));
	maxusers = 32;
	maxconnectionsperip = 5;
	idletimeout = 300;
	freefilesize = -1;
	dataportrangeL = 2000;
	dataportrangeH = 3000;
	port = 21;
	packetsize = 4096;
	usessl = false;
	dtree = NULL;
	SHUTDOWN = false;
	RESTART = false;

	//myParser = new parser();

	users = (user **) mymalloc(maxusers*sizeof(user*));
	incomingfile= (char **) mymalloc(maxusers*sizeof(char*));
	totalpath = (char **) mymalloc(maxusers*sizeof(char*));
	subdirs = (char **) mymalloc(maxusers*sizeof(char*));
	currentdir = (folder **) mymalloc(maxusers*sizeof(folder*));
	tls_cnx = (SSL **) mymalloc(maxusers*sizeof(SSL*));
	data_tls_cnx = (SSL **) mymalloc(maxusers*sizeof(SSL*));
	datasock = (SOCKET*)mymalloc(maxusers*sizeof(SOCKET));
	sidinuse = (bool*)mymalloc(maxusers*sizeof(bool));
	DIEBITCH = (bool*)mymalloc(maxusers*sizeof(bool));
	resumeval = (int*)mymalloc(maxusers*sizeof(int));
	mode = (int*)mymalloc(maxusers*sizeof(int));

	RemoteAddr = (u_long*)mymalloc(maxusers*sizeof(u_long));

	for(int i=0;i<maxusers;i++)
	{
		DIEBITCH[i] = false;
		mode[i] = 0;
		resumeval[i] = 0;
		subdirs[i] = NULL;
		incomingfile[i] = NULL;
		this->setsubdirs(i,"");
		this->setincomingfile(i,"");	
		totalpath[i] = (char*)mymalloc(sizeof(char));
		strcpy_s(totalpath[i],1,"");


		sidinuse[i] = false;
		datasock[i] = NULL;
		tls_cnx[i] = NULL;
		data_tls_cnx[i] = NULL;
		users[i] = NULL;
		currentdir[i] = NULL;

	}



	//finding ip address of server
	//probobly will find a prettier way to do this later
	char ac[80];
	if (gethostname(ac, sizeof(ac)) == SOCKET_ERROR) {
		//	cerr << "Error " << WSAGetLastError() <<" when getting local host name." << "\n";
	}


	struct hostent *phe = gethostbyname(ac);
	if (phe == 0) {
		//cerr << "Bad host lookup (you suck at life)" << endl;
	}
	struct in_addr addr;

	//hack for having just one up address

	// for (int i = 0; phe->h_addr_list[i] != 0; ++i) {

	memcpy(&addr, phe->h_addr_list[0], sizeof(struct in_addr));

	// }

	strncpy_s(IP,16,inet_ntoa(addr),strlen(inet_ntoa(addr)));



	//setting current ops stuff
	currentusers = 0;



}

void ftp_options::forcesave()
{
	xml_manager *xmlm = new xml_manager("options.xml");
	xmlm->saveOptions(this);
	delete xmlm;

}

ftp_options::~ftp_options()
{
	xml_manager *xmlm = new xml_manager("options.xml");
	xmlm->saveOptions(this);
	delete xmlm;
	//	delete myParser;
	free(users);
	free(incomingfile);
	free(totalpath);
	free(subdirs);
	free(currentdir);
	free(tls_cnx);
	free(data_tls_cnx);
	free(datasock);
	free(sidinuse);
	free(resumeval);
	free(DIEBITCH);

}


//standard getter and setter functions, should need no explanation

char* ftp_options::getIP()
{
	return IP;
}


char* ftp_options::getName()
{
	return name;
}

int ftp_options::getMaxusers()
{
	return maxusers;
}
int ftp_options::getMaxconnectionsperip()
{
	return maxconnectionsperip;
}
int ftp_options::getIdletimeout()
{
	return idletimeout;
}
int ftp_options::getFreefilesize()
{
	return freefilesize;
}

int ftp_options::getDataportrangeL()
{
	return dataportrangeL;
}

int ftp_options::getDataportrangeH()
{
	return dataportrangeH;
}
int ftp_options::getPort()
{
	return port;
}

int ftp_options::getPacketsize()
{
	return packetsize;
}

void ftp_options::setName(char *a)
{
	strcpy_s(name,50,a);
}
void ftp_options::setMaxusers(int a)
{
	if(a<currentusers)
	{
		return;
	}
	int oldmax = maxusers;
	maxusers = a;


	currentdir = (folder **)myrealloc(currentdir,maxusers*sizeof(folder*));
	totalpath = (char **)myrealloc(totalpath,maxusers*sizeof(char*));	
	incomingfile = (char **)myrealloc(incomingfile,maxusers*sizeof(char*));	
	subdirs = (char **)myrealloc(subdirs,maxusers*sizeof(char*));	
	users = (user **)myrealloc(users,maxusers*sizeof(user*));
	tls_cnx = (SSL **)myrealloc(tls_cnx,maxusers*sizeof(SSL*));
	data_tls_cnx = (SSL **)myrealloc(data_tls_cnx,maxusers*sizeof(SSL*));
	datasock = (SOCKET*)myrealloc(datasock,maxusers*sizeof(SOCKET));
	sidinuse = (bool*)myrealloc(sidinuse,maxusers*sizeof(bool));
	DIEBITCH = (bool*)myrealloc(DIEBITCH,maxusers*sizeof(bool));
	resumeval = (int*)myrealloc(resumeval,maxusers*sizeof(int));
	mode = (int*)myrealloc(mode,maxusers*sizeof(int));
	RemoteAddr = (u_long*)myrealloc(RemoteAddr,maxusers*sizeof(u_long));
	for(int i=oldmax;i<maxusers;i++)
	{
		resumeval[i] = 0;
		DIEBITCH[i] = false;
		mode[i] = 0;
		totalpath[i] = (char*)mymalloc(sizeof(char));
		strcpy_s(totalpath[i],1,"");

		subdirs[i] = NULL;
		incomingfile[i] = NULL;
		this->setsubdirs(i,"");
		this->setincomingfile(i,"");	
		sidinuse[i] = false;
		datasock[i] = NULL;
		tls_cnx[i] = NULL;
		data_tls_cnx[i] = NULL;
		users[i] = NULL;
		currentdir[i] = NULL;
	}




}
void ftp_options::setMaxconnectionsperip(int a)
{
	maxconnectionsperip = a;
}
void ftp_options::setIdletimeout(int a)
{
	idletimeout = a;
}
void ftp_options::setFreefilesize(int a)
{
	freefilesize = a;
}
void ftp_options::setDataportrangeL(int a)
{
	dataportrangeL = a;
}
void ftp_options::setDataportrangeH(int a)
{
	dataportrangeH = a;
}
void ftp_options::setPort(int a)
{
	port = a;
}

void ftp_options::setIP(char *a)
{
	if(!strlen(a))
	{
//finding ip address of server
	//probobly will find a prettier way to do this later
	char ac[80];
	if (gethostname(ac, sizeof(ac)) == SOCKET_ERROR) {
		//	cerr << "Error " << WSAGetLastError() <<" when getting local host name." << "\n";
	}


	struct hostent *phe = gethostbyname(ac);
	if (phe == 0) {
		//cerr << "Bad host lookup (you suck at life)" << endl;
	}
	struct in_addr addr;

	//hack for having just one up address

	// for (int i = 0; phe->h_addr_list[i] != 0; ++i) {

	memcpy(&addr, phe->h_addr_list[0], sizeof(struct in_addr));

	// }

	strncpy_s(IP,16,inet_ntoa(addr),strlen(inet_ntoa(addr)));
	return;
	}
	
	strncpy_s(IP,16,a,strlen(a));
}

void ftp_options::setPacketsize(int a)
{
	packetsize = a;
}


int ftp_options::incCurrentUsers()
{



	if(currentusers>=maxusers)
	{
		return OVERMAXUSERS;
	}
	currentusers++;

	for(int i=0;i<maxusers;i++)
	{
		if(!sidinuse[i])
		{
			sidinuse[i] = true;
			return i;
		}
	}
	return UNKNOWNERROR;

}

void ftp_options::decCurrentUsers(int sid)
{
	currentusers--;
	sidinuse[sid] = false;
	users[sid] = false;

}


int ftp_options::getCurrentUsers()
{

	return currentusers;

}
int ftp_options::addUsers(user *a, int sid)
{


	if(sidinuse[sid])
	{
		users[sid] = a;

		return SUCCESSFUL;
	}
	return UNKNOWNERROR;


}


//removes a user from the list of current users
int ftp_options::remUsers(user *a, int sid)
{
	m_Critical.Lock();
	if( (sid>maxusers) || (sid<0) || (users[sid]==NULL) )
	{
		m_Critical.Unlock();
		return USERNOTFOUND;
	}


	users[sid]=NULL;
	datasock[sid] = NULL;
	tls_cnx[sid] = NULL;
	this->setcurrentdir(sid,NULL);
	this->setsubdirs(sid,"");
	DIEBITCH[sid] = false;
	if(this->getNumConnections(a) == 0)
	{
		delete a;

	}

	m_Critical.Unlock();
	return SUCCESSFUL;


}


bool ftp_options::getRESTART()
{
	return RESTART;
}
void ftp_options::setRESTART(bool a)
{
	RESTART = a;
}


bool ftp_options::getSHUTDOWN()
{
	return SHUTDOWN;
}
void ftp_options::setSHUTDOWN(bool a)
{
	SHUTDOWN = a;
}


int ftp_options::getNumConnections(user *a)
{
	int cnt = 0;

	for(int i=0;i<maxusers;i++)
	{
		//check if users is a matchs
		if( (sidinuse[i]) && (users[i]!=NULL) )
		{

			if(!strcmp(a->getname(),users[i]->getname()))
			{
				cnt++;
			}
		}

	}

	return cnt;

}



int ftp_options::getDataSock(int sid)
{

	if( (users[sid]==NULL) || (!sidinuse[sid]) )
	{
		//temp hack, fix this
		return USERNOTFOUND;
	}

	return datasock[sid];
}



int ftp_options::setDataSock(int sid, SOCKET sd)
{
	m_Critical.Lock();
	if( (users[sid]==NULL) || (!sidinuse[sid]) )
	{
		//temp hack, fix this
		return USERNOTFOUND;
	}

	datasock[sid] = sd;

	m_Critical.Unlock();

	return SUCCESSFUL;

}

SSL* ftp_options::getSSL(int sid)
{
	if(!sidinuse[sid])
	{
		return NULL;
	}
	return tls_cnx[sid];

}

int ftp_options::setSSL(int sid, SSL *a)
{
	m_Critical.Lock();
	if(!sidinuse[sid])
	{
		m_Critical.Unlock();
		return USERNOTFOUND;
	}
	tls_cnx[sid] = a;

	m_Critical.Unlock();
	return SUCCESSFUL;

}





SSL* ftp_options::getdataSSL(int sid)
{
	if(!sidinuse[sid])
	{

		return NULL;
	}

	return data_tls_cnx[sid];

}

int ftp_options::setdataSSL(int sid, SSL *a)
{
	m_Critical.Lock();
	if(!sidinuse[sid])
	{
		m_Critical.Unlock();
		return USERNOTFOUND;
	}
	data_tls_cnx[sid] = a;
	m_Critical.Unlock();
	return SUCCESSFUL;

}



folder* ftp_options::getcurrentdir(int sid)
{


	if(!sidinuse[sid])
	{


		return NULL;
	}

	return currentdir[sid];

}

int ftp_options::setcurrentdir(int sid, folder *a)
{
	m_Critical.Lock();
	if(!sidinuse[sid])
	{
		m_Critical.Unlock();
		return USERNOTFOUND;
	}
	currentdir[sid] = a;
	m_Critical.Unlock();
	return SUCCESSFUL;

}


void ftp_options::setusessl(bool a)
{
	usessl = a;
}

bool ftp_options::getusessl()
{
	return usessl;
}


//this function returns the top node in a tree that can be accessed by a group
//the group id is sent in grp
//a user can only access someone in the tree that is equal of thier grp value or a lower value
folder* ftp_options::getdtree(int grp)
{
	group *tmp;

	//if there is a group for this folder
	//this should always be the case, it is not allowed to have a folder without a group
	if(dtree->getGfirst() != NULL)
	{
		//assign the tmp group value
		tmp = dtree->getGfirst();
		//loop though till we get to the end of the list
		while(tmp != NULL)
		{
			//if the user group number is greater then that of the folder of equal we retun true
			if(tmp->getName() <= grp)
			{
				return dtree;
			}
			//move to the next node
			tmp = tmp->getNext();
		};

	}
	else
	{
		//this should never ever happen, bad mojo if this happens
		//PS the yankees suck

		return NULL;
	}


	//check to see if we can move down to the next level of the directory tree
	if(dtree->getDown() == NULL)
	{
		//there is no tree below us
		//nothing left to check
		//return null because you have no rights to anything
		return NULL;
	}
	else
	{
		//asign the folder pointer to the first folder in the next level of the tree	
		folder *fldr = dtree->getDown();
		//loop though this level till we are at the end of the linked list	
		while(fldr != NULL)
		{
			//calling a function that checks the groups in this folder
			folder *rfldr = checkgroups(fldr,grp);
			//if we returned a folder return the folder at the level above it
			//we return the level above to allow for multiple folders at that level that we can see
			if(rfldr != NULL)
			{
				return rfldr->getUp();
			}
			//move to the next node in the list
			fldr = fldr->getNext();
		};

	}

	//return null if we find no folder that the group id has rights too
	return NULL;

}


folder* ftp_options::checkgroups(folder *fldr, int grp)
{

	group *tmp;

	if(fldr->getGfirst() != NULL)
	{
		tmp = fldr->getGfirst();
		while(tmp != NULL)
		{
			if(tmp->getName() <= grp)
			{
				return fldr;
			}
			tmp = tmp->getNext();
		};

	}
	else
	{

		return NULL;
	}



	if(fldr->getDown() == NULL)
	{
		//nothing left to check
		return NULL;
	}
	else
	{
		folder *fldr2 = fldr->getDown();
		while(fldr2 != NULL)
		{
			folder *rfldr = checkgroups(fldr2,grp);
			if(rfldr != NULL)
			{
				return rfldr;
			}
			fldr2 = fldr2->getNext();
		};

	}

	return NULL;

}




void ftp_options::setdtree(folder *a)
{
	m_Critical.Lock();
	dtree = a;
	m_Critical.Unlock();
}


void ftp_options::setincomingfile(int sid, char *a)
{
	incomingfile[sid] = (char*)myrealloc(incomingfile[sid],(strlen(a)+1)*sizeof(char));

	strcpy_s(incomingfile[sid],strlen(a)+1,a);

}

char* ftp_options::getincomingfile(int sid)
{
	return incomingfile[sid];
}


void ftp_options::setsubdirs(int sid, char *a)
{
	subdirs[sid] = (char*)myrealloc(subdirs[sid],(strlen(a)+1)*sizeof(char));

	strcpy_s(subdirs[sid],strlen(a)+1,a);

}

char* ftp_options::getsubdirs(int sid)
{
	return subdirs[sid];
}


void ftp_options::delsubdir(int sid)
{
	int sl = strslash(strlen(subdirs[sid]),subdirs[sid]);
	subdirs[sid][sl+1] = '\0';
	subdirs[sid] = (char*)myrealloc(subdirs[sid],(strlen(subdirs[sid])+1)*sizeof(char));


}
void ftp_options::addsubdir(int sid, char *a)
{

	subdirs[sid] = (char*)myrealloc(subdirs[sid],(strlen(subdirs[sid])+strlen(a)+2)*sizeof(char));
	strcat_s(subdirs[sid],(strlen(subdirs[sid])+strlen(a)+2),a);
	strcat_s(subdirs[sid],(strlen(subdirs[sid])+strlen(a)+2),"/");
}



char* ftp_options::gettotalpath(int sid)
{

	int uplength = 0;
	folder *tmp = NULL;

	//if(this->getcurrentdir(sid)->getUp() != NULL)
	//{
	tmp = this->getcurrentdir(sid);
	//}
	while(tmp != NULL)
	{
		uplength += strlen(tmp->getName())+1;
		tmp = tmp->getUp();
	};


	totalpath[sid] = (char*)myrealloc( totalpath[sid] , (strlen(subdirs[sid])+2+uplength)*sizeof(char) );

	totalpath[sid][0] = '\0';


	tmp = this->getcurrentdir(sid);
	char *tempstr = (char*)mymalloc((uplength+1)*sizeof(char));
	while(tmp != NULL)
	{
		strcpy_s(tempstr,uplength+1,totalpath[sid]);
		sprintf_s(totalpath[sid],uplength+1,"%s/%s",tmp->getName(),tempstr);
		tmp = tmp->getUp();
	};
	free(tempstr);
	//strcpy_s(totalpath[sid],(strlen(subdirs[sid])+1+uplength),name);

	strcat_s(totalpath[sid],(strlen(subdirs[sid])+2+uplength),subdirs[sid]);

	return totalpath[sid];
}

char* ftp_options::gettotalrealpath(int sid)
{
	char *location = this->getcurrentdir(sid)->getLocation();
	totalpath[sid] = (char*)myrealloc(totalpath[sid],(strlen(subdirs[sid])+strlen(location)+1)*sizeof(char));


	strcpy_s(totalpath[sid],(strlen(subdirs[sid])+strlen(location)+1),location);

	strcat_s(totalpath[sid],(strlen(subdirs[sid])+strlen(location)+1),subdirs[sid]);

	switchbsfs(strlen(totalpath[sid]),totalpath[sid]);

	return totalpath[sid];


}


void ftp_options::setresumeval(int sid, int a)
{
	resumeval[sid] = a;
}
int ftp_options::getresumeval(int sid)
{
	return resumeval[sid];
}


SSL_CTX* ftp_options::getctx()
{
	return tls_ctx;
}
void ftp_options::setctx(SSL_CTX *a)
{
	tls_ctx = a;
}



u_long ftp_options::getremoteIP(int sid)
{
	return RemoteAddr[sid];
}
void ftp_options::setremoteIP(int sid, u_long a)
{
	RemoteAddr[sid] = a;
}


user* ftp_options::getusers(int sid)
{
	////std::cout<<"gettting current user sid = "<<sid<<" user = "<<users[sid]<<"\n";
	return users[sid];
}





user* ftp_options::getUserByName(char *a)
{
	int cnt = 0;

	for(int i=0;i<maxusers;i++)
	{
		//check if users is a matchs
		if( (sidinuse[i]) && (users[i]!=NULL) )
		{

			if(!strcmp(a,users[i]->getname()))
			{
				return  users[i];
			}
		}

	}

	return NULL;

}

int ftp_options::getmode(int sid)
{
	return mode[sid];
}

void ftp_options::setmode(int sid,int mod)
{
	mode[sid] = mod;
}



long long ftp_options::getBWlimit()
{
	return BWlimit;
}
int ftp_options::getBWlimitType()
{
	return BWlimitType;
}
int ftp_options::getresetat()
{
	return resetat;
}
long long ftp_options::getbwthissession()
{
	return bwthissession;
}

bool ftp_options::incbwthissession(long long a)
{
	m_Critical.Lock();
	if(BWlimitType)
	{
		bwthissession += a;
	}
	m_Critical.Unlock();
	if(bwthissession > BWlimit)
	{
		return false;
	}
	else
	{
		return true;
	}

}
void ftp_options::resetbwthisession()
{
	m_Critical.Lock();
	bwthissession = 0;
	m_Critical.Unlock();
}

void ftp_options::setBWlimit(long long a)
{
	m_Critical.Lock();
	BWlimit = a;
	m_Critical.Unlock();
}
void ftp_options::setBWlimitType(int a)
{
	m_Critical.Lock();
	BWlimitType = a;
	m_Critical.Unlock();
}
void ftp_options::setresetat(int a)
{
	m_Critical.Lock();
	resetat = a;
	m_Critical.Unlock();
}
void ftp_options::setbwthissession(long long a)
{
	m_Critical.Lock();
	bwthissession = a;
	m_Critical.Unlock();
}

bool ftp_options::getDIEBITCH(int sid)
{
	return DIEBITCH[sid];
}
void ftp_options::setDIEBITCH(int sid, bool a)
{
	DIEBITCH[sid] = a;
}