/***********************************************
** ftp_options.h       horseshoeFTPd          **
** Nick Byra                                  **
** 21/03/06                                   **
**                                            **
***********************************************/

#ifndef _FTPOPTIONS
#define _FTPOPTIONS





#include "stdafx.h"
#include <winsock2.h>
#include <openssl/ssl.h>
#include "filefolders.h"
//#include "parser.h"
#include "user.h"



class ftp_options
{
public:

ftp_options();
~ftp_options();

char* getName();
int getMaxusers();
int getMaxconnectionsperip();
int getIdletimeout();
int getFreefilesize();
int getDataportrangeL();
int getDataportrangeH();
int getPort();
int getPacketsize();
char* getIP();
bool getusessl();

void setName(char *a);
void setMaxusers(int a);
void setMaxconnectionsperip(int a);
void setIdletimeout(int a);
void setFreefilesize(int a);
void setDataportrangeL(int a);
void setDataportrangeH(int a);
void setPort(int a);
void setPacketsize(int a);
void setIP(char *a);
void setusessl(bool a);

	

public:
int setDataSock(int sid, SOCKET sd);



//current op getters and setters
int getCurrentUsers();
int addUsers(user *a, int sid);
int remUsers(user *a,int sid);
int getNumConnections(user *a);
int incCurrentUsers();
void decCurrentUsers(int sid);
int getDataSock(int sid);

user* getusers(int sid);

SSL* getSSL(int sid);
int setSSL(int sid, SSL *a);

SSL_CTX* getctx();
void setctx(SSL_CTX *a);

SSL* getdataSSL(int sid);
int setdataSSL(int sid, SSL *a);


folder* getcurrentdir(int sid);
int setcurrentdir(int sid, folder *a);

folder* getdtree(int grp);
void setdtree(folder *a);


char* gettotalpath(int sid);
char* gettotalrealpath(int sid);
void setsubdirs(int sid, char *a);
char* getsubdirs(int sid);
void delsubdir(int sid);
void addsubdir(int sid, char *a);


void setincomingfile(int sid, char *a);
char* getincomingfile(int sid);

void setresumeval(int sid, int a);
int getresumeval(int sid);

u_long getremoteIP(int sid);
void setremoteIP(int sid, u_long a);
user* getUserByName(char *a);

int getmode(int sid);
void setmode(int sid,int mod);

void forcesave();







long long getBWlimit();
int getBWlimitType();
int getresetat();
long long getbwthissession();

bool incbwthissession(long long a);
void resetbwthisession();

void setBWlimit(long long a);
void setBWlimitType(int a);
void setresetat(int a);
void setbwthissession(long long a);

bool getDIEBITCH(int sid);
void setDIEBITCH(int sid, bool a);

bool getSHUTDOWN();
void setSHUTDOWN(bool a);

bool getRESTART();
void setRESTART(bool a);


//parser* getparser();

private:
char name[50];
int maxusers;
int maxconnectionsperip;
int idletimeout;
int freefilesize;
int dataportrangeL;
int dataportrangeH;
int port;
int packetsize;
char IP[16];
bool usessl;
long long BWlimit;
int BWlimitType;
int resetat;
long long bwthissession;
bool SHUTDOWN;
bool RESTART;


CCriticalSection m_Critical;

//current op values
user **users;
SOCKET *datasock;
int currentusers;
SSL **tls_cnx;
SSL **data_tls_cnx;
bool *sidinuse;
folder *dtree;
folder **currentdir;
char **totalpath;
char **subdirs;
char **incomingfile;
int *resumeval;
SSL_CTX *tls_ctx;
u_long *RemoteAddr;
int *mode;
bool *DIEBITCH;
//parser *myParser;


folder* checkgroups(folder *fldr, int grp);

};

#endif
