/***********************************************
** logging.cpp     horseshoeFTPd              **
** Nick Byra                                  **
** 21/03/06                                   **
**                                            **
***********************************************/

#include "logging.h"
#include "stdafx.h"
#include "consts.h"
#include "helpfunctions.h"

void Log(int type, char *user, int action, char *file, int status, unsigned long IP)
{
	char tmp[16];
	getIPstring(IP,tmp);
	char myline[1024];

	time_t ltime;
	char buf[26];
	time( &ltime );
	ctime_s( buf, 26, &ltime );

	//because for some reason ctime_s puts a newline in at the end
	buf[24] = '\0';


	sprintf_s(myline,1024,"<%s time=\"%s\" user=\"%s\" action=\"%s\" file=\"%s\" status=\"%s\" IP=\"%s\" />",getType(type),buf,user,getAction(action),file,getStatus(status),tmp);


	writeLog(myline);


}


void Log(int type,char *user,int status,unsigned int IP)
{
	char tmp[16];
	getIPstring(IP,tmp);
	char myline[1024];

	time_t ltime;
	char buf[26];
	time( &ltime );
	ctime_s( buf, 26, &ltime );

	//because for some reason ctime_s puts a newline in at the end
	buf[24] = '\0';


	sprintf_s(myline,1024,"<%s time=\"%s\" user=\"%s\" status=\"%s\" IP=\"%s\" />",getType(type),buf,user,getStatus(status),tmp);


	writeLog(myline);


}

void Log(int type, unsigned long IP)
{
	char tmp[16];
	getIPstring(IP,tmp);
	char myline[1024];

	time_t ltime;
	char buf[26];
	time( &ltime );
	ctime_s( buf, 26, &ltime );

	//because for some reason ctime_s puts a newline in at the end
	buf[24] = '\0';


	sprintf_s(myline,1024,"<%s time=\"%s\" IP=\"%s\" />",getType(type),buf,tmp);


	writeLog(myline);

}


void Log(int type, int action, char *user, int typeaction, char *gname, int status,char *newval, unsigned long IP)
{

	char tmp[16];
	getIPstring(IP,tmp);
	char myline[1024];

	time_t ltime;
	char buf[26];
	time( &ltime );
	ctime_s( buf, 26, &ltime );

	//because for some reason ctime_s puts a newline in at the end
	buf[24] = '\0';


	sprintf_s(myline,1024,"<%s time=\"%s\" action=\"%s\" user=\"%s\" typeaction=\"%s\" group_name=\"%s\" status=\"%s\" new_value=\"%s\" IP=\"%s\" />",getType(type),buf,getAction(action),user,getTypeAction(typeaction),gname,getStatus(status),newval,tmp);


	writeLog(myline);



}



char* getStatus(int status)
{

	if(status == STARTED) return "Started";
	if(status == OUTOFCREDITS) return "Out of Credits";
	if(status == OVERUSERQUOTA) return "Over user bandwidth quota";
	if(status == OVERGLOBALQUOTA) return "Over global bandwidth quota";
	if(status == ERRORREADINGFILE) return "Error reading file";
	if(status == COMPLETE) return "Complete";
	if(status == RESUMING) return "Resuming";
	if(status == ABORTSENT) return "Abort Sent";
	if(status == OUTOFDISKSPACE) return "Out of Diskspace";
	if(status == UNKNOWNERROR) return "Unknown error";
	if(status == ERROR) return "Error";
	if(status == DATATIMEOUT) return "Timeout";
	if(status == ACCOUNTDISABLED) return "Account disabled";
	if(status == INVALIDIP) return "Invalid IP";
	if(status == OVERMAXLOGINS) return "Over max logins";
	if(status == LOGGEDIN) return "Logged in";
	if(status == INVALIDPASSWORD) return "Invalid password";
	if(status == USERNOTFOUND) return "User not found";
	if(status == UNKNOWNERROR) return "Unknown error";
	if(status == SERVERFULL) return "Server full";
	if(status == NOTFOUND) return "Not found";
	if(status == ACCESSDENIED) return "Access denied";

	return "unknown";

}

char* getType(int type)
{
	if(type == TRANSFER) return "Transfer";
	if(type == SETTINGCHANGE) return "Changesetting";
	if(type == CONNECTION) return "Connection";
	if(type == LOGIN) return "Login";
	if(type == LOGOFF) return "Logout";

	return "unknown";

}

char* getAction(int action)
{
	if(action == DOWNLOAD) return "Download";
	if(action == UPLOAD) return "Upload";
	if(action == USER) return "User";
	if(action == USERGROUP) return "UserGroup";
	if(action == DELETE) return "Delete";
	if(action == RENAME) return "Rename";

	return "unknown";

}


char* getTypeAction(int typeaction)
{
	if(typeaction == CHANGEALLOWFXP) return "Changing allow FXP";
	if(typeaction == CHANGEBWLIMIT) return "Changing bandwidth limit";
	if(typeaction == CHANGEBWLIMITTYPE) return "Changing bandwidth limit type";
	if(typeaction == CHANGEIPONFXP) return "Changing IP on FXP";
	if(typeaction == CHANGEFREEFILESIZE) return "Changing free file size";
	if(typeaction == CHANGEPREMISSIONS) return "Changing permissions";
	if(typeaction == CHANGEMAXDOWNLOADSPEED) return "Changing max download speed";
	if(typeaction == CHANGEMAXLOGINS) return "Changing max logins";
	if(typeaction == CHANGEMAXUPLOADSPEED) return "Changing max upload speed";
	if(typeaction == CHANGERATIOD) return "Changing ratio d";
	if(typeaction == CHANGERATION) return "Changing ratio n";

	return "unknown";

}



void writeLog(char *line)
{

	FILE *hFile;
	CCriticalSection m_Critical;
	m_Critical.Lock();
	if(int err = fopen_s(&hFile,"log.xml","a+"))
	{
		return;
	}
	int len = strlen(line);
	line[len] = '\n';

	fwrite(line,sizeof(char),len+1,hFile);
	fclose(hFile);
	m_Critical.Unlock();

}