/***********************************************
** ls.cpp              horseshoeFTPd          **
** Nick Byra                                  **
** 21/03/06                                   **
**                                            **
***********************************************/

#include "ls.h"
#include "helpfunctions.h"
#include <time.h>
#include <string.h>
#include <locale.h>
#include <direct.h>
#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include "auth.h"

//read a directory and send the listing to the clent
void scan(SOCKET sd, char *dir, const char *pattern, tcp_manager *tcpman, SSL *tls_cnx, folder *fldr,int sid)
{
	//intialize local variables  
	struct _finddata_t fileinfo;
	long handle;
	char temp[1024];
	char buf[1024];

	//making a buffer of the packersize to send the dir listing in
	//only large directorys will need more then one packet
	char *lbuf = (char*)calloc(tcpman->getserverOptions()->getPacketsize(),sizeof(char));
	int blen = 0;

	if(authGroupList(fldr,tcpman->getserverOptions()->getusers(sid)->getgroup()))
	{
		//set the directory and any patern to match, usuall * but can use any wildcard combo
		sprintf_s(temp,1024, "%s\\%s", dir, pattern);
		handle = _findfirst(temp, &fileinfo);
		//if there handle was created successfully
		if(handle != -1)
		{
			//more local char buffers
			char c_time[128];
			char sub[1024];


			//loop though till all files are processes
			do
			{
				//if it is a regular file and not a directory
				if(!(fileinfo.attrib & _A_SUBDIR))
				{

					//getting relevant atrributes and formating them
					tm tmp;
					localtime_s(&tmp, &fileinfo.time_create);
					strftime(c_time, sizeof(c_time), "%b %d %H:%M", &tmp);
					sprintf_s(sub,1024, "%s", fileinfo.name);
					//created the text for one file with attributes
					blen += sprintf_s(buf,1024,"-rw-r--r-- 1 owner group %d %s %s\r\n", fileinfo.size,c_time,sub);

					//if the new buffer length would be leager then the buffer
					if(blen > tcpman->getserverOptions()->getPacketsize()-1)
					{
						//send the buffer work of directory listings to the client
						tcpman->senddirlisting(sd,lbuf,strlen(lbuf),tls_cnx);
						//clear out the buffer
						clearbuff(lbuf,tcpman->getserverOptions()->getPacketsize());
						//set the last file line to the new cleared out buffer
						strcpy_s(lbuf,tcpman->getserverOptions()->getPacketsize(),buf);
						//set blen to the length of the new buffer
						blen = strlen(lbuf);
					}
					else
					{
						//if the buffer is not full add the new line to the buffer
						strcat_s(lbuf,tcpman->getserverOptions()->getPacketsize(),buf);
					}
				}
				//if it is a directory and not a file
				if((fileinfo.attrib & _A_SUBDIR) && strcmp(fileinfo.name, ".") && strcmp(fileinfo.name, ".."))
				{
					//get directory attributes and format them
					tm tmp;
					localtime_s(&tmp, &fileinfo.time_create);
					strftime(c_time, sizeof(c_time), "%b %d %H:%M", &tmp);
					sprintf_s(sub,1024, "%s", fileinfo.name);
					//create line of text for directory
					blen += sprintf_s(buf,1024,"drw-r--r-- 1 owner group %d %s %s\r\n", fileinfo.size,c_time,sub);
					//if the buffer would be full
					if(blen > tcpman->getserverOptions()->getPacketsize()-1)
					{
						//send the buffer to the client
						tcpman->senddirlisting(sd,lbuf,strlen(lbuf),tls_cnx);
						//clear out the buffer
						clearbuff(lbuf,tcpman->getserverOptions()->getPacketsize());
						//copy the last string into the new buffer
						strcpy_s(lbuf,tcpman->getserverOptions()->getPacketsize(),buf);
						//set blen to the length of the new buffer
						blen = strlen(lbuf);
					}
					else
					{
						//if buffer would not be full just add the last line to the buffer
						strcat_s(lbuf,tcpman->getserverOptions()->getPacketsize(),buf);
					}
				}

			}
			while(_findnext(handle, &fileinfo) == 0);
			//close the file handle for the directory   
			_findclose(handle);
		}
	}

	//handle virtual directorys
	if(fldr != NULL)
	{
		fldr = fldr->getDown();
	}
	//std::cout<<"before vdir while loop\n";
	//while there are still folders to check
	//does not check folders if we are in a subdirectory
	while((fldr != NULL) && (!strcmp(tcpman->getserverOptions()->getsubdirs(sid),"")))
	{

		//std::cout<<"in vdir while loop\n";
		if(authGroupList(fldr,tcpman->getserverOptions()->getusers(sid)->getgroup()))
		{

			//hardcoded stuff for the virtual directorys
			blen += sprintf_s(buf,1024,"drw-r--r-- 1 owner group %d %s %s\r\n", 0,"May 17 23:33",fldr->getName());
			//if the buffer would be full
			if(blen > tcpman->getserverOptions()->getPacketsize()-1)
			{
				//send the buffer to the client
				tcpman->senddirlisting(sd,lbuf,strlen(lbuf),tls_cnx);
				//clear out the buffer
				clearbuff(lbuf,tcpman->getserverOptions()->getPacketsize());
				//copy the last string into the new buffer
				strcpy_s(lbuf,tcpman->getserverOptions()->getPacketsize(),buf);
				//set blen to the length of the new buffer
				blen = strlen(lbuf);
			}
			else
			{
				//if buffer would not be full just add the last line to the buffer
				strcat_s(lbuf,tcpman->getserverOptions()->getPacketsize(),buf);
			}

		}

		//setting fldr to the next one in teh list
		fldr = fldr->getNext();



	};


	//send the remaining data in the buffer to the client
	tcpman->senddirlisting(sd,lbuf,strlen(lbuf),tls_cnx);

	//free the memory alloced when  the buffer was created
	free (lbuf);

}






//get the size of a file in bytes
long long getfilesize(char *dir, const char *pattern)
{
	struct _finddata_t fileinfo;
	long handle;
	char temp[1024];


	//the directory will the the path of the file and the pattern will be its name
	sprintf_s(temp,1024, "%s\\%s", dir, pattern);
	handle = _findfirst(temp, &fileinfo);
	//if the file was found
	if(handle != -1)
	{

		//if its a file not a directory
		if(!(fileinfo.attrib & _A_SUBDIR))
		{
			//closeing the file handle
			_findclose(handle);
			//returning its filesize 
			return fileinfo.size;
		}

		//closing the file handle
		_findclose(handle);
	}
	//returning a file not found error if the file was not found
	return FILENOTFOUND;

}



//this simply checks to see if a directory exists
bool checkdir(char *dir, const char *pattern, folder *fldr, user *myUser)
{
	struct _finddata_t fileinfo;
	long handle;
	char temp[1024];
	int mygroup;

	if(myUser == NULL)
	{
		mygroup = ROOTGROUP;
	}
	else
	{
		mygroup = myUser->getgroup();
	}

	if(authGroupList(fldr,mygroup ))
	{
		/* First parse any files in this directory */
		sprintf_s(temp,1024, "%s\\%s", dir, pattern);
		handle = _findfirst(temp, &fileinfo);
		if(handle != -1)
		{

			do
			{

				if((fileinfo.attrib & _A_SUBDIR) && strcmp(fileinfo.name, ".") && strcmp(fileinfo.name, ".."))
				{
					//this was a REALLY REALLY dumb thing to forget to put in
					//close the bloody handle before we return
					_findclose(handle);
					return true;
				}
			}
			while(_findnext(handle, &fileinfo) == 0);
			_findclose(handle);
		}
	}


	//making sure we don't segfault by doing something with a null pointer
	if(fldr != NULL)
	{
		//setting fldr to the next level down in the tree
		fldr = fldr->getDown();
	}

	//looping though all the entires in this level of fldr to see if we have a match
	while(fldr != NULL)
	{
		if(authGroupList(fldr,mygroup))
		{
			//if there is a match we return true
			if(!strcmp(pattern,fldr->getName()))
			{
				return true;
			}
		}
		fldr = fldr->getNext();
	};

	//no match so we return false
	return false;
}



//this simply checks to see if a directory exists
bool checkRealdir(char *dir, const char *pattern)
{
	struct _finddata_t fileinfo;
	long handle;
	char temp[1024];
	int mygroup;

	/* First parse any files in this directory */
	if(strlen(pattern))
	{
		sprintf_s(temp,1024, "%s\\%s", dir, pattern);
	}
	else
	{
		sprintf_s(temp,1024, "%s", dir);
	}
	handle = _findfirst(temp, &fileinfo);
	if(handle != -1)
	{

		do
		{

			if((fileinfo.attrib & _A_SUBDIR) && strcmp(fileinfo.name, ".") && strcmp(fileinfo.name, ".."))
			{
				//this was a REALLY REALLY dumb thing to forget to put in
				//close the bloody handle before we return
				_findclose(handle);
				return true;
			}
		}
		while(_findnext(handle, &fileinfo) == 0);
		_findclose(handle);
	}

	//no match so we return false
	return false;
}







//check to see is the directory is a virtual directory
//need for the cases when it needs to be handled differently because it is a virtual directory
//example fir renameing the directory
bool checkVdir(const char *pattern, folder *fldr)
{

	//making sure we don't segfault by doing this will a null pointer
	if(fldr != NULL)
	{
		fldr = fldr->getDown();
	}

	//looping though the level
	while(fldr != NULL)
	{
		//returning true if we have a match
		if(!strcmp(pattern,fldr->getName()))
		{
			return true;
		}
		fldr = fldr->getNext();
	};

	//returning false if there is no match
	return false;
}




bool checkfile(char *dir, const char *pattern)
{
	struct _finddata_t fileinfo;
	long handle;
	char temp[1024];


	//combines the dir and the pattern to get the search string
	sprintf_s(temp,1024, "%s\\%s", dir, pattern);
	handle = _findfirst(temp, &fileinfo);
	//if we have a match
	if(handle != -1)
	{

		do
		{
			//we confirm is a file not a directory
			if(!(fileinfo.attrib & _A_SUBDIR))
			{
				//return true because it is a file
				//and yes i did it again, i forgot to close the file handle
				//bug fixed
				_findclose(handle);
				return true;
			}
		}
		while(_findnext(handle, &fileinfo) == 0);
		_findclose(handle);
	}

	//return false if there was no match found
	return false;
}
