/***********************************************
** user.cpp           horseshoeFTPd           **
** Nick Byra                                  **
** 21/03/06                                   **
**                                            **
***********************************************/


#include "user.h"
#include "xml_manager.h"
#include "helpfunctions.h"
#include "consts.h"
//using namespace std;



user::user()
{
	this->loadDefault();
}

user::~user()
{

	xml_manager *xmlm = new xml_manager("user.xml");
	xmlm->saveUser(this);
	delete xmlm;


}

void user::forcesave()
{
	xml_manager *xmlm = new xml_manager("user.xml");
	xmlm->saveUser(this);
	delete xmlm;
}

void user::loadDefault()
{
	//load default user settings

	active = true;
	fxp = true;

	IPfxp = false;

	credits = -1;
	BWlimitType = 0;
	BWlimit = 0;
	maxLogins = 1;
	downloaded = 0;
	uploaded = 0;
	ratio_d = -1;
	ratio_n = -1;
	freeFileSize = 0;
	maxUpSpeed = 0;
	maxDownSpeed = 0;
	expDate = 0;
	locktogroup = false;
	cmulti = 0;

	first = NULL;


}

void user::printValues()
{
	/*	
	//std::cout<<" active "<<active<<"\n";
	//std::cout<<" fxp "<<fxp<<"\n";
	//std::cout<<" IPfxp "<<IPfxp<<"\n";
	//std::cout<<" name "<<name<<"\n";
	//std::cout<<" group "<<group<<"\n";
	//std::cout<<" password "<<user::password<<"\n";
	//std::cout<<" credits "<<credits<<"\n";
	//std::cout<<" BWlimitType "<<BWlimitType<<"\n";
	//std::cout<<" BWlimit "<<BWlimit<<"\n";
	//std::cout<<" maxLogins "<<maxLogins<<"\n";
	//std::cout<<" downloaded "<<downloaded<<"\n";
	//std::cout<<" uploaded "<<uploaded<<"\n";
	//std::cout<<" ratio_d "<<ratio_d<<"\n";
	//std::cout<<" ratio_n "<<ratio_n<<"\n";
	//std::cout<<" freeFileSize "<<freeFileSize<<"\n";
	//std::cout<<" maxUpSpeed "<<maxUpSpeed<<"\n";
	//std::cout<<" maxDownSpeed "<<maxDownSpeed<<"\n";
	//std::cout<<" expDate "<<expDate<<"\n";
	*/

}


bool user::checkActive()
{
	return active;
}

bool user::checkIP(char *ip)
{
	return 0;
}

bool user::checkMaxLogins()
{
	return 0;
}

bool user::checkPassword(char *pw)
{
	//std::cout<<"passwords = "<<pw<<" : "<<password<<"\n";

	return (!strcmp(pw,password));

}

bool user::checkPasswordrequired()
{
	return (strlen(password)!=0);
}


bool user::checkExpDate(int date)
{

	return 0;
}


bool user::checkBW(int filesize)
{
	return 0;
}

bool user::checkFreeFileSize(int filesize)
{
	return 0;
}

bool user::checkRatio(int filesize)
{
	return ((credits*(ratio_n/ratio_d)) >= filesize);
}

bool user::checkPremission(char *filename)
{
	return 0;
}



//standard getters and setters, shouldn't need any explanation


char* user::getgroupname()
{
	return groupname;
}
void user::setgroupname(char *a)
{
	strcpy_s(groupname,30,a);

	xml_manager *myxml = new xml_manager("group.xml");
	usergroup *mygroup = myxml->loadGroup(a);
	delete myxml;
	//if the group does not exist, bail
	if(mygroup == NULL)
	{
		return;
	}
	group = mygroup->getgroup();

	if(locktogroup)
	{



		fxp = mygroup->getfxp();
		IPfxp = mygroup->getIPfxp();
		group = mygroup->getgroup();
		BWlimitType = mygroup->getBWlimitType();
		BWlimit = mygroup->getBWlimit();
		maxLogins = mygroup->getmaxLogins();
		ratio_d = mygroup->getratio_d();
		ratio_n = mygroup->getratio_n();
		freeFileSize = mygroup->getfreeFileSize();
		maxUpSpeed = mygroup->getmaxUpSpeed();
		maxDownSpeed = mygroup->getmaxDownSpeed();


	}
	delete mygroup;


}


bool user::getactive()
{
	return active;
}
bool user::getfxp()
{
	return fxp;
}

bool user::getIPfxp()
{
	return IPfxp;
}
char* user::getname()
{
	return name;
}
int user::getgroup()
{
	return group;
}
char* user::getpassword()
{
	return password;
}
long long user::getcredits()
{
	return credits;
}
int user::getBWlimitType()
{
	return BWlimitType;
}
int user::getBWlimit()
{
	return BWlimit;
}
int user::getmaxLogins()
{
	return maxLogins;
}
long long user::getdownloaded()
{
	return downloaded;
}
long long user::getuploaded()
{
	return uploaded;
}
int user::getratio_d()
{
	return ratio_d;
}
int user::getratio_n()
{
	return ratio_n;
}
int user::getfreeFileSize()
{
	return freeFileSize;
}
int user::getmaxUpSpeed()
{
	return maxUpSpeed;
}
int user::getmaxDownSpeed()
{
	return maxDownSpeed;
}
int user::getexpDate()
{
	return expDate;
}


void user::setactive(bool a){active = a;}
void user::setfxp(bool a)
{
	//std::cout<<"fxp is set too "<<a<<"\n";
	fxp=a;
}

void user::setIPfxp(bool a)
{
	IPfxp= a;
}
void user::setname(char *a)
{
	strncpy_s(name,30,a,strlen(a));
	//std::cout<<"name in setter is "<<name<<"\n";
}
void user::setgroup(int a)
{
	group = a;
}
void user::setpassword(char *a)
{
	strncpy_s(password,41,a,strlen(a));
}
void user::setcredits(long long a)
{
	if( (ratio_n < 0) || (ratio_d < 0) )
	{
		credits = -1;
	}
	else
	{
		credits= a;
	}
}
void user::setBWlimitType(int a)
{
	BWlimitType= a;
}
void user::setBWlimit(int a)
{
	BWlimit= a;
}
void user::setmaxLogins(int a)
{
	maxLogins= a;
}
void user::setdownloaded(long long a)
{
	downloaded= a;
}
void user::setuploaded(long long a)
{
	uploaded= a;
}
void user::setratio_d(int a)
{
	ratio_d= a;
	cmulti = ratio_n/ratio_d;
	if( (cmulti < 0) || (ratio_n < 0) || (ratio_d < 0) )
	{
		cmulti = 0;
	}
}
void user::setratio_n(int a)
{
	ratio_n= a;
	cmulti = ratio_n/ratio_d;
	if( (cmulti < 0) || (ratio_n < 0) || (ratio_d < 0) )
	{
		cmulti = 0;
	}
}
void user::setfreeFileSize(int a)
{
	freeFileSize= a;
}
void user::setmaxUpSpeed(int a)
{
	maxUpSpeed= a;
}
void user::setmaxDownSpeed(int a)
{
	maxDownSpeed= a;
}
void user::setexpDate(int a)
{
	expDate= a;
}

void user::setDataSocket(SOCKET a)
{
	DataSocket = a;
}

SOCKET user::getDataSocket()
{
	return DataSocket;
}


IPrules* user::getiprules()
{
	return first;
}

void user::setiprules(IPrules *a)
{
	first = a;
}


void user::incUp(long long amount)
{
	m_Critical.Lock();
	uploaded += amount;	
	m_Critical.Unlock();
	this->incCredits(amount);
	//this->incBW(amount);


}
bool user::incDown(long long amount)
{
	m_Critical.Lock();
	downloaded += amount;
	if(credits>=0)
	{
		this->decCredits(amount);
		if(credits<0)
		{
			credits = 0;
			m_Critical.Unlock();
			return false;
		}
		else
		{
			m_Critical.Unlock();
			return true;
		}
	}
	m_Critical.Unlock();
	return true;
}


void user::incCredits(long long amount)
{
	m_Critical.Lock();
	if(cmulti)
	{
		credits += (amount*cmulti);
		////std::cout<<"credits = "<<credits<<"\n";
	}

	m_Critical.Unlock();

}

void user::decCredits(long long amount)
{
	m_Critical.Lock();
	if(cmulti)
	{
		credits -= (amount*cmulti);
		if(credits < 0)
		{
			credits = 0;
		}
	}

	m_Critical.Unlock();
}


bool user::incBW(long long amount)
{
	m_Critical.Lock();
	bwthissession += amount;
	m_Critical.Unlock();

	if(bwthissession > BWlimit)
	{
		this->setbwthissession(this->getBWlimit());

		if(this->getBWlimitType())
		{
			return false;
		}
	}

	return true;
}


long long user::getbwthissession()
{
	return bwthissession;
}

void user::setbwthissession(long long a)
{

	m_Critical.Lock();
	bwthissession = a;
	m_Critical.Unlock();
}


int user::getresetat()
{
	return resetat;
}
void user::setresetat(int a)
{
	m_Critical.Lock();
	resetat = a;
	m_Critical.Unlock();
}


bool user::getlocktogroup()
{
	return locktogroup;
}

void user::setlocktogroup(bool a)
{
	m_Critical.Lock();
	locktogroup = a;

	if(locktogroup)
	{
		xml_manager *myxml = new xml_manager("group.xml");
		usergroup *mygroup = myxml->loadGroup(groupname);
		delete myxml;
		//if the group does not exist, bail
		if(mygroup == NULL)
		{
			return;
		}

		fxp = mygroup->getfxp();
		IPfxp = mygroup->getIPfxp();
		group = mygroup->getgroup();
		BWlimitType = mygroup->getBWlimitType();
		BWlimit = mygroup->getBWlimit();
		maxLogins = mygroup->getmaxLogins();
		ratio_d = mygroup->getratio_d();
		ratio_n = mygroup->getratio_n();
		freeFileSize = mygroup->getfreeFileSize();
		maxUpSpeed = mygroup->getmaxUpSpeed();
		maxDownSpeed = mygroup->getmaxDownSpeed();

		delete mygroup;
	}


	m_Critical.Unlock();
}

bool user::addIPrules(IPrules *a)
{
	//check if the first node is empty
	//star the list with a if that is the case
	if(first == NULL)
	{
		first = a;
	}
	else
	{
		IPrules *ptr = first;
		//check to see if it is a duplicate ip rule
		//return false and do nothign if it is
		if(!strcmp(ptr->getipmask(),a->getipmask()))
		{
			return false;
		}
		//loop though the list to find the end
		while(ptr->getnext() != NULL)
		{
			//move to the next node
			ptr = ptr->getnext();
			//check to see if it is a duplicate ip rule
			//return false and do nothign if it is
			if(!strcmp(ptr->getipmask(),a->getipmask()))
			{
				return false;
			}
		};
		//set node a to the last node in the list
		ptr->setnext(a);
	}

	//return true if there aas no error
	return true;
}


bool user::delIPrules(char *a)
{
	//if there are no first node return false
	//this should not be possible since every user must have one iprule
	//but we check anyway just in case something fucked up
	if(first == NULL)
	{
		return false;
	}
	else
	{
		IPrules *ptr = first;

		//if the first node is a match
		if(!strcmp(ptr->getipmask(),a))
		{
			//check to see if it is the only node
			//if it is return false since we can't delete the only node
			if(ptr->getnext() == NULL)
			{
				return false;
			}
			//if the node is not the only one delete it and change the pointers
			first = ptr->getnext();
			delete ptr;
			return true;
		}

		//look though the list till we find a match or reach the end
		while(ptr->getnext() != NULL)
		{
			//check for a match
			if(!strcmp(ptr->getnext()->getipmask(),a))
			{
				//change the pointers and delete the node
				// return true
				IPrules *holder = ptr->getnext();
				ptr->setnext(ptr->getnext()->getnext());
				delete holder;
				return true;
			}
			//go to the next node
			ptr = ptr->getnext();


		};

	}
	//if there was no match we return false
	return false;
}



IPrules::IPrules(char *a,bool b)
{
	//std::cout<<"creating IPrules "<<a<<" "<<b<<"\n";
	strcpy_s(ipmask ,32,a);
	allow = b;
	next = NULL;
}

IPrules::~IPrules()
{

}

char* IPrules::getipmask()
{
	////std::cout<<"the ip mask in the getter is "<<ipmask<<"\n";
	return ipmask;
}

void IPrules::setipmask(char *a)
{
	strcpy_s(ipmask ,32,a);
}

IPrules* IPrules::getnext()
{
	return next;
}

void IPrules::setnext(IPrules *a)
{
	next = a;
}

bool IPrules::getallow()
{
	return allow;
}
void IPrules::setallow(bool a)
{
	allow = a;
}

















usergroup::usergroup()
{
	this->loadDefault();
}

usergroup::~usergroup()
{

	/*xml_manager *xmlm = new xml_manager("user.xml");
	xmlm->saveUser(this);
	delete xmlm;*/


}

void usergroup::forcesave()
{
	/*	xml_manager *xmlm = new xml_manager("user.xml");
	xmlm->saveUser(this);
	delete xmlm;*/
}

void usergroup::loadDefault()
{
	//load default user settings


	fxp = true;

	IPfxp = false;


	BWlimitType = 0;
	BWlimit = 0;
	maxLogins = 1;

	ratio_d = -1;
	ratio_n = -1;
	freeFileSize = 0;
	maxUpSpeed = 0;
	maxDownSpeed = 0;


}



//standard getters and setters, shouldn't need any explanation


bool usergroup::getfxp()
{
	return fxp;
}

bool usergroup::getIPfxp()
{
	return IPfxp;
}
char* usergroup::getname()
{
	return name;
}
int usergroup::getgroup()
{
	return group;
}

int usergroup::getBWlimitType()
{
	return BWlimitType;
}
int usergroup::getBWlimit()
{
	return BWlimit;
}
int usergroup::getmaxLogins()
{
	return maxLogins;
}

int usergroup::getratio_d()
{
	return ratio_d;
}
int usergroup::getratio_n()
{
	return ratio_n;
}
int usergroup::getfreeFileSize()
{
	return freeFileSize;
}
int usergroup::getmaxUpSpeed()
{
	return maxUpSpeed;
}
int usergroup::getmaxDownSpeed()
{
	return maxDownSpeed;
}



void usergroup::setfxp(bool a)
{
	//std::cout<<"fxp is set too "<<a<<"\n";
	fxp=a;
	updateusers("Allow_Fxp",getTF(a));
}

void usergroup::setIPfxp(bool a)
{
	IPfxp= a;

	updateusers("Check_IP_for_FXP",getTF(a));
}
void usergroup::setname(char *a)
{
	strncpy_s(name,30,a,strlen(a));
	//std::cout<<"name in setter is "<<name<<"\n";
}
void usergroup::setgroup(int a)
{
	group = a;
	char tmp[ITOABUFF];
	_i64toa_s(a,tmp,ITOABUFF,10);
	updateusers("Group_permissions",tmp);
}


void usergroup::setBWlimitType(int a)
{
	BWlimitType= a;
	char tmp[ITOABUFF];
	_i64toa_s(a,tmp,ITOABUFF,10);
	updateusers("Bandwidth_limit_type",tmp);
}
void usergroup::setBWlimit(int a)
{
	BWlimit= a;
	char tmp[ITOABUFF];
	_i64toa_s(a,tmp,ITOABUFF,10);
	updateusers("Bandwidth_limit",tmp);
}
void usergroup::setmaxLogins(int a)
{
	maxLogins= a;
	char tmp[ITOABUFF];
	_i64toa_s(a,tmp,ITOABUFF,10);
	updateusers("Max_Logins",tmp);
}

void usergroup::setratio_d(int a)
{
	ratio_d= a;
	char tmp[ITOABUFF];
	_i64toa_s(a,tmp,ITOABUFF,10);
	updateusers("Ratio_D",tmp);

}
void usergroup::setratio_n(int a)
{
	ratio_n= a;
	char tmp[ITOABUFF];
	_i64toa_s(a,tmp,ITOABUFF,10);
	updateusers("Ratio_N",tmp);

}
void usergroup::setfreeFileSize(int a)
{
	freeFileSize= a;
	char tmp[ITOABUFF];
	_i64toa_s(a,tmp,ITOABUFF,10);
	updateusers("Free_file_size",tmp);
}
void usergroup::setmaxUpSpeed(int a)
{
	maxUpSpeed= a;
	char tmp[ITOABUFF];
	_i64toa_s(a,tmp,ITOABUFF,10);
	updateusers("Max_Upload_Speed",tmp);
}
void usergroup::setmaxDownSpeed(int a)
{
	maxDownSpeed= a;
	char tmp[ITOABUFF];
	_i64toa_s(a,tmp,ITOABUFF,10);
	updateusers("Max_Download_Speed",tmp);
}


void usergroup::updateusers(char *setting, char *value)
{

	xml_manager *myxml = new xml_manager("user.xml");
	myxml->updateUser(name,setting,value);
	delete myxml;

}