/***********************************************
** user.h              horseshoeFTPd          **
** Nick Byra                                  **
** 21/03/06                                   **
**                                            **
***********************************************/


#ifndef _USER
#define _USER

#include "stdafx.h"
#include <string>
#include <iostream>
#include <winsock2.h>

//using namespace std; 



class IPrules
{
public:
	IPrules(char *a,bool b);
	~IPrules();
	char* getipmask();
	void setipmask(char *a);
	IPrules* getnext();
	void setnext(IPrules *a);
	bool getallow();
	void setallow(bool a);
private:
	IPrules *next;
	char ipmask[32];
	bool allow;

};



class user
{
public:
	user();
	~user();
	void loadDefault();
	void printValues();

	bool checkActive();
	bool checkIP(char *ip);
	bool checkMaxLogins();
	bool checkPassword(char *pw);
	bool checkExpDate(int date);
	bool checkPasswordrequired();

	bool checkBW(int filesize);
	bool checkFreeFileSize(int filesize);
	bool checkRatio(int filesize);
	bool checkPremission(char *filename);

	bool getactive();
	bool getfxp();

	bool getIPfxp();
	char* getname();
	int getgroup();
	char* getpassword();
	long long getcredits();
	int getBWlimitType();
	int getBWlimit();
	int getmaxLogins();
	long long getdownloaded();
	long long getuploaded();
	int getratio_d();
	int getratio_n();
	int getfreeFileSize();
	int getmaxUpSpeed();
	int getmaxDownSpeed();
	int getexpDate();

	SOCKET getDataSocket();

	void setactive(bool a);
	void setfxp(bool a);

	void setIPfxp(bool a);
	void setname(char *a);
	void setgroup(int a);
	void setpassword(char *a);
	void setcredits(long long a);
	void setBWlimitType(int a);
	void setBWlimit(int a);
	void setmaxLogins(int a);
	void setdownloaded(long long a);
	void setuploaded(long long a);
	void setratio_d(int a);
	void setratio_n(int a);
	void setfreeFileSize(int a);
	void setmaxUpSpeed(int a);
	void setmaxDownSpeed(int a);
	void setexpDate(int a);

	void setDataSocket(SOCKET a);
	IPrules* getiprules();
	void setiprules(IPrules *a);



	void incUp(long long amount);
	bool incDown(long long amount);

	bool incBW(long long amount);

	

	void incCredits(long long amount);
	void decCredits(long long amount);

	void forcesave();

	int getresetat();
	void setresetat(int a); 
	long long getbwthissession();
	void setbwthissession(long long a);

	bool getlocktogroup();
	void setlocktogroup(bool a);

	bool addIPrules(IPrules *a);
	bool delIPrules(char *a);

	char* getgroupname();
	void setgroupname(char *a);

private:
	bool active;
	bool fxp;
bool locktogroup;
	bool IPfxp;
	char name[30];
	char groupname[30];
	int group;
	char password[41];
	long long credits;
	int BWlimitType;
	int BWlimit;
	int maxLogins;
	long long downloaded;
	long long uploaded;
	int ratio_d;
	int ratio_n;
	int freeFileSize;
	int maxUpSpeed;
	int maxDownSpeed;
	int expDate;
	float cmulti;
	long long bwthissession;

	int resetat;

	IPrules *first;
	SOCKET DataSocket;

	CCriticalSection m_Critical;




};



class usergroup
{
public:
	usergroup();
	~usergroup();
	void loadDefault();
	bool getfxp();

	bool getIPfxp();
	char* getname();
	int getgroup();

	int getBWlimitType();
	int getBWlimit();
	int getmaxLogins();

	int getratio_d();
	int getratio_n();
	int getfreeFileSize();
	int getmaxUpSpeed();
	int getmaxDownSpeed();

	void setfxp(bool a);

	void setIPfxp(bool a);
	void setname(char *a);
	void setgroup(int a);

	void setBWlimitType(int a);
	void setBWlimit(int a);
	void setmaxLogins(int a);

	void setratio_d(int a);
	void setratio_n(int a);
	void setfreeFileSize(int a);
	void setmaxUpSpeed(int a);
	void setmaxDownSpeed(int a);

void forcesave();


private:
	
	void updateusers(char *setting, char *value);
	char name[30];
	bool fxp;
	bool IPfxp;
	int group;
	int BWlimitType;
	int BWlimit;
	int maxLogins;
	int ratio_d;
	int ratio_n;
	int freeFileSize;
	int maxUpSpeed;
	int maxDownSpeed;


	CCriticalSection m_Critical;




};


#endif