/***********************************************
** xml_mamager.h       horseshoeFTPd          **
** Nick Byra                                  **
** 21/03/06                                   **
**                                            **
***********************************************/


#ifndef _XML_MANAGER
#define _XML_MANAGER

#define X(str) XStr(str).unicodeForm()

//#include "stdafx.h"
#include <xercesc/parsers/XercesDOMParser.hpp>
#include <xercesc/dom/DOM.hpp>
#include <xercesc/dom/DOMWriter.hpp>
#include <xercesc/sax/HandlerBase.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/framework/LocalFileFormatTarget.hpp>
#include "user.h"
#include "ftp_options.h"
#include "filefolders.h"



class xml_manager
{
public:
xml_manager(char *xmlfile);
xml_manager();
~xml_manager();
user* loadUser(char *username);
int saveUser(user *myUser);
int newUser(user *myUser);
ftp_options* loadOptions();
folder* loadDir();
usergroup* loadGroup(char *groupname);
int saveUsergroup(usergroup *myUsergroup);
int newUsergroup(usergroup *myUser);

int saveOptions(ftp_options *myOptions);
 int saveDir(folder* dtree);
int delUser(char *username);
int updateUser(char *groupname,char *setting, char *value);
bool checkIfGroupUsed(char *groupname);


private:
	void procSaveFolder(XERCES_CPP_NAMESPACE::DOMElement*  sElem,folder *fldr, XERCES_CPP_NAMESPACE::DOMDocument *mydoc);
	folder* procFolder(XERCES_CPP_NAMESPACE::DOMNodeList *nlist);
XERCES_CPP_NAMESPACE::XercesDOMParser *parser;
XERCES_CPP_NAMESPACE::ErrorHandler *errHandler;
XERCES_CPP_NAMESPACE::DOMNode *doc;
void writeXML(char *file);
char filename[30];

};


class XStr
{
public :
    // -----------------------------------------------------------------------
    //  Constructors and Destructor
    // -----------------------------------------------------------------------
    XStr(const char* const toTranscode)
    {
        // Call the private transcoding method
        fUnicodeForm = XERCES_CPP_NAMESPACE::XMLString::transcode(toTranscode);
    }

    ~XStr()
    {
        XERCES_CPP_NAMESPACE::XMLString::release(&fUnicodeForm);
    }


    // -----------------------------------------------------------------------
    //  Getter methods
    // -----------------------------------------------------------------------
    const XMLCh* unicodeForm() const
    {
        return fUnicodeForm;
    }

private :
    // -----------------------------------------------------------------------
    //  Private data members
    //
    //  fUnicodeForm
    //      This is the Unicode XMLCh format of the string.
    // -----------------------------------------------------------------------
    XMLCh*   fUnicodeForm;
};

#endif